SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'DB 9/13/2012 20:42' prior: 0!
this handles the cells of the game !

!SBECell methodsFor: 'initialization' stamp: 'DB 9/13/2012 20:47'!
initialize
	super initialize.	
	self label:''.
	self borderWidth:2.
	bounds :=0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'DB 9/14/2012 00:08'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'DB 9/14/2012 00:11'!
mouseUp: anEvent
	mouseAction value
	! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'DB 9/13/2012 23:18' prior: 0!
handles the game!

!SBEGame methodsFor: 'initialization' stamp: 'DB 9/14/2012 00:14'!
cellsPerSide
"The number of cells along each side of the game"
 ^10! !

!SBEGame methodsFor: 'initialization' stamp: 'DB 9/13/2012 23:33'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'DB 9/16/2012 20:53'!
newCellAt: i at: j
 	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) *  c width) @ ((j-1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	  ^c
	! !

!SBEGame methodsFor: 'game logic' stamp: 'DB 9/14/2012 00:03'!
toggleNeighboursOfCellAt: i at: j
	(i> 1) ifTrue: [ (cells at: i - 1 at: j) toggleState].
	(i< self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j> 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j< self cellsPerSide) ifTrue: [ ( cells at: i at: j +1) toggleState].! !
